#ifndef WBST_H_
#define WBST_H_

#include <utility>
#include <vector>

//input item (key,weight)
struct Item
{
  Item(int k, unsigned w): key(k),weight(w) {};
  int key;
  unsigned weight;
};

//node in a binary search tree
struct Node;
struct Node
{
  Node(): l(0),r(0),key(0){};
  Node(int a_key, Node* a_l, Node* a_r):l(a_l),r(a_r),key(a_key) {};
  ~Node(){};
  Node* l; //left
  Node* r; //right
  int key;
};

//constructs a weighted BST on items given as input
Node* wbst(std::vector<Item>& items);

#endif

